## python-autobahn 21.11.1%2Bdfsg1

=== debian/changelog ===
python-autobahn (21.11.1+dfsg1-2build1) jammy; urgency=medium

  * No-change rebuild with Python 3.10 only

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 16 Mar 2022 21:44:48 +0000

python-autobahn (21.11.1+dfsg1-2) unstable; urgency=medium

  * Add missing debian/python3-autobahn.install.

 -- Thomas Goirand <zigo@debian.org>  Tue, 28 Dec 2021 19:44:31 +0100

python-autobahn (21.11.1+dfsg1-1) unstable; urgency=medium

  [ Ondřej Nový ]
  * Run wrap-and-sort -bastk.

  [ Thomas Goirand ]
  * New upstream release.
  * Fixed (build-)depends for this release.
  * Removed py 3.7 patch, not needed anymore.
  * pytest: Use -Wignore to ignore deprecation warnings.
  * Add export USE_ASYNCIO = 1 in debian/rules.
  * Correctly set the test folder when running tests.

 -- Thomas Goirand <zigo@debian.org>  Tue, 08 Sep 2020 10:15:16 +0200
