=== debian/control ===
--- 
+++ 
@@ -8,28 +8,37 @@
  debhelper-compat (= 10),
  dh-python,
  openstack-pkg-tools (>= 99~),
+ python3-all,
+ python3-setuptools,
  python3-sphinx,
  python3-sphinx-rtd-theme,
- python3-all,
- python3-setuptools,
 Build-Depends-Indep:
- python3-cbor (>= 1.0.0),
+ python3-attr (>= 19.2.0),
+ python3-base58,
+ python3-cbor,
+ python3-cffi (>= 1.11.5),
+ python3-cryptography (>= 3.3.2),
+ python3-ecdsa,
+ python3-flatbuffers,
  python3-enchant,
+ python3-hyperlink,
  python3-lz4,
- python3-mock,
+ python3-mnemonic,
+ python3-msgpack (>= 1.0.2),
  python3-nacl,
  python3-openssl,
+ python3-passlib,
  python3-pyqrcode,
  python3-pytest,
- python3-service-identity,
- python3-six,
+ python3-pytest-asyncio,
+ python3-service-identity (>= 18.1.0),
  python3-snappy,
- python3-trie,
- python3-twisted,
- python3-txaio,
+ python3-trie (>= 0.4.0),
+ python3-twisted (>= 20.3.0),
+ python3-txaio (>= 21.2.1),
  python3-u-msgpack,
  python3-ubjson,
- python3-unittest2,
+ python3-ujson,
  python3-wsaccel,
  python3-zope.interface,
 Standards-Version: 4.1.1
@@ -40,19 +49,29 @@
 Package: python3-autobahn
 Architecture: all
 Depends:
- python3-cbor (>= 1.0.0),
+ python3-attr (>= 19.2.0),
+ python3-base58,
+ python3-cbor,
+ python3-cffi (>= 1.11.5),
+ python3-cryptography (>= 3.3.2),
+ python3-ecdsa,
+ python3-flatbuffers,
+ python3-hyperlink,
  python3-lz4,
+ python3-mnemonic,
+ python3-msgpack (>= 1.0.2),
  python3-nacl,
  python3-openssl,
+ python3-passlib,
  python3-pyqrcode,
- python3-service-identity,
- python3-six,
+ python3-service-identity (>= 18.1.0),
  python3-snappy,
- python3-trie,
+ python3-trie (>= 0.4.0),
  python3-twisted,
- python3-txaio,
+ python3-txaio (>= 21.2.1),
  python3-u-msgpack,
  python3-ubjson,
+ python3-ujson,
  python3-wsaccel,
  python3-zope.interface,
  ${misc:Depends},
