## python-autobahn 22.1.1+dfsg1

=== Makefile ===
--- 
+++ 
@@ -69,7 +69,7 @@
 
 # publish to PyPI
 publish: clean
-	AUTOBAHN_USE_NVX=0 python setup.py sdist --universal
+	AUTOBAHN_USE_NVX=0 python setup.py sdist
 	twine upload dist/*
 
 clean_docs:
@@ -101,7 +101,7 @@
 build_this_wheel:
 	mkdir -p ./.wheels/
 	rm -f ./.wheels/autobahn*.whl
-	pip3 wheel --no-deps --wheel-dir=./.wheels ..
+	pip3 wheel --no-deps --wheel-dir=./.wheels .
 	mv .wheels/autobahn*.whl .wheels/autobahn-latest-py2.py3-none-any.whl
 	ls -la ./.wheels
