=== debian/changelog ===
python-autobahn (22.1.1+dfsg1-3) unstable; urgency=medium

  * Add dh_python3 --shebang=/usr/bin/python3 (Closes: #1017048).

 -- Thomas Goirand <zigo@debian.org>  Mon, 15 Aug 2022 15:44:51 +0200

python-autobahn (22.1.1+dfsg1-2) unstable; urgency=medium

  * Uploading to unstable.

 -- Thomas Goirand <zigo@debian.org>  Wed, 23 Mar 2022 15:47:31 +0100

python-autobahn (22.1.1+dfsg1-1) experimental; urgency=medium

  * New upstream release.

 -- Thomas Goirand <zigo@debian.org>  Wed, 16 Feb 2022 10:58:15 +0100
