=== debian/rules ===
--- 
+++ 
@@ -36,3 +36,6 @@
 override_dh_clean:
 	dh_clean -O--buildsystem=python_distutils
 	rm -rf build twisted/plugins/dropin.cache
+
+override_dh_python3:
+	dh_python3 --shebang=/usr/bin/python3
