## python-autobahn 22.7.1%2Bdfsg1

=== debian/rules ===
--- 
+++ 
@@ -8,14 +8,13 @@
 export AUTOBAHN_USE_NVX=0
 export AUTOBAHN_USE_UJSON=1
 export AUTOBAHN_USE_CBOR2=0
-export USE_TWISTED=0
-export USE_ASYNCIO = 1
+export USE_ASYNCIO=1
 
 %:
 	dh $@ --buildsystem=python_distutils --with python3
 
 override_dh_auto_clean:
-	rm -rf build .stestr
+	rm -rf build .stestr .pytest_cache *.egg-info
 	find . -iname '*.pyc' -delete
 	for i in $$(find . -type d -iname __pycache__) ; do rm -rf $$i ; done
